Index: blog/edit.php
=========================================================
--- blog/edit.php	(revision 1.82)
+++ blog/edit.php	Thu Oct 29 10:00:21 WST 2009
@@ -27,17 +27,36 @@
 require_once(dirname(dirname(__FILE__)).'/config.php');
 include_once('lib.php');
 include_once('locallib.php');
-include_once($CFG->dirroot.'/tag/lib.php');
 
 $action   = required_param('action', PARAM_ALPHA);
 $id       = optional_param('entryid', 0, PARAM_INT);
 $confirm  = optional_param('confirm', 0, PARAM_BOOL);
-$modid    = optional_param('modid', 0, PARAM_INT);
-$courseid = optional_param('courseid', 0, PARAM_INT); // needed for user tab - does nothing here
+$modid    = optional_param('modid', 0, PARAM_INT); // To associate the entry with a module instance
+$courseid = optional_param('courseid', 0, PARAM_INT); // To associate the entry with a course
 
 $PAGE->set_url('blog/edit.php', array('action' => $action, 'entryid' => $id, 'confirm' => $confirm, 'modid' => $modid, 'courseid' => $courseid));
 
-$blog_headers = blog_get_headers();
+// If action is add, we ignore $id to avoid any further problems
+if (!empty($id) && $action == 'add') {
+    $id = null;
+}
+
+$returnurl = new moodle_url($CFG->wwwroot . '/blog/index.php');
+
+if (!empty($courseid) && empty($modid)) {
+    $returnurl->param('courseid', $courseid);
+    $PAGE->set_context(get_context_instance(CONTEXT_COURSE, $courseid));
+}
+
+// If a modid is given, guess courseid
+if (!empty($modid)) {
+    $returnurl->param('modid', $modid);
+    $courseid = $DB->get_field('course_modules', 'course', array('id' => $modid));
+    $returnurl->param('courseid', $courseid);
+    $PAGE->set_context(get_context_instance(CONTEXT_MODULE, $modid));
+}
+
+$blogheaders = blog_get_headers();
 
 require_login($courseid);
 
@@ -58,117 +77,120 @@
     print_error('cannoteditentryorblog');
 }
 
-$returnurl = new moodle_url($CFG->wwwroot . '/blog/index.php');
-
-// Make sure that the person trying to edit have access right
+// Make sure that the person trying to edit has access right
 if ($id) {
-    if (!$existing = new blog_entry($id)) {
+    if (!$entry = new blog_entry($id)) {
         print_error('wrongentryid', 'blog');
     }
 
-    if (!blog_user_can_edit_entry($existing)) {
+    if (!blog_user_can_edit_entry($entry)) {
         print_error('notallowedtoedit', 'blog');
     }
-    $userid    = $existing->userid;
-    $returnurl->param('userid', $existing->userid);
+    $userid = $entry->userid;
 } else {
     if (!has_capability('moodle/blog:create', $sitecontext)) {
         print_error('noentry', 'blog'); // manageentries is not enough for adding
     }
-    $existing  = false;
+    $entry  = new stdClass();
+    $entry->id = null;
-    $userid    = $USER->id;
+    $userid = $USER->id;
-    $returnurl->param('userid', $userid);
-}
-
-if (!empty($courseid) && empty($modid)) {
-    $returnurl->param('courseid', $courseid);
-    $PAGE->set_context(get_context_instance(CONTEXT_COURSE, $courseid));
-}
-
-// If a modid is given, guess courseid
-if (!empty($modid)) {
-    $returnurl->param('modid', $modid);
-    $courseid = $DB->get_field('course_modules', 'course', array('id' => $modid));
-    $returnurl->param('courseid', $courseid);
-    $PAGE->set_context(get_context_instance(CONTEXT_MODULE, $modid));
 }
+$returnurl->param('userid', $userid);
 
 $strblogs = get_string('blogs','blog');
 
 if ($action === 'delete'){
-    if (!$existing) {
+    if (empty($entry->id)) {
         print_error('wrongentryid', 'blog');
     }
     if (data_submitted() && $confirm && confirm_sesskey()) {
-        $existing->delete();
+        // Make sure the current user is the author of the blog entry, or has some deleteanyentry capability
+        if (!blog_user_can_edit_entry($entry)) {
+            print_error('nopermissionstodeleteentry', 'blog');
+        } else {
+            $entry->delete();
-        redirect($returnurl);
+            redirect($returnurl);
-    } else {
+        }
+    } else if (blog_user_can_edit_entry($entry)) {
         $optionsyes = array('entryid'=>$id, 'action'=>'delete', 'confirm'=>1, 'sesskey'=>sesskey(), 'courseid'=>$courseid);
-        $optionsno = array('userid'=>$existing->userid, 'courseid'=>$courseid);
+        $optionsno = array('userid'=>$entry->userid, 'courseid'=>$courseid);
         $PAGE->set_title("$SITE->shortname: $strblogs");
         $PAGE->set_heading($SITE->fullname);
         echo $OUTPUT->header();
-        //blog_print_entry($existing);
-        $existing->print_html();
+        $entry->print_html();
         echo '<br />';
         echo $OUTPUT->confirm(get_string('blogdeleteconfirm', 'blog'), new moodle_url('edit.php', $optionsyes),new moodle_url( 'index.php', $optionsno));
         echo $OUTPUT->footer();
         die;
     }
+} else if ($action == 'add') {
+    $PAGE->set_title("$SITE->shortname: $strblogs: " . get_string('addnewentry', 'blog'));
+    $PAGE->set_heading($SITE->shortname);
+} else if ($action == 'edit') {
+    $PAGE->set_title("$SITE->shortname: $strblogs: " . get_string('editentry', 'blog'));
+    $PAGE->set_heading($SITE->shortname);
 }
 
-require_once('edit_form.php');
-
-if (!empty($existing)) {
-    if ($blogassociations = $DB->get_records('blog_association', array('blogid' => $existing->id))) {
+if (!empty($entry->id)) {
+    if ($CFG->useblogassociations && ($blogassociations = $DB->get_records('blog_association', array('blogid' => $entry->id)))) {
 
         foreach ($blogassociations as $assocrec) {
             $contextrec = $DB->get_record('context', array('id' => $assocrec->contextid));
 
             switch ($contextrec->contextlevel) {
                 case CONTEXT_COURSE:
-                    $existing->courseassoc = $assocrec->contextid;
+                    $entry->courseassoc = $assocrec->contextid;
                     break;
                 case CONTEXT_MODULE:
-                    $existing->modassoc[] = $assocrec->contextid;
+                    $entry->modassoc = $assocrec->contextid;
                     break;
             }
         }
     }
 }
 
-$textfieldoptions = array('trusttext'=>true, 'subdirs'=>true);
-$blogeditform = new blog_edit_form(null, compact('existing', 'sitecontext', 'textfieldoptions', 'id'));
-$draftitemid = file_get_submitted_draft_itemid('attachments');
-file_prepare_draft_area($draftitemid, $PAGE->context->id, 'blog_attachment', empty($id)?null:$id);
+require_once('edit_form.php');
+$summaryoptions = array('subdirs'=>false, 'maxfiles'=> 99, 'maxbytes'=>$CFG->maxbytes, 'trusttext'=>true, 'context'=>$sitecontext);
+$attachmentoptions = array('subdirs'=>false, 'maxfiles'=> 99, 'maxbytes'=>$CFG->maxbytes);
+
+$blogeditform = new blog_edit_form(null, compact('entry', 'summaryoptions', 'attachmentoptions', 'sitecontext', 'courseid', 'modid'));
+
+$entry = file_prepare_standard_editor($entry, 'summary', $summaryoptions, $sitecontext, 'blog_post', $entry->id);
+$entry = file_prepare_standard_filemanager($entry, 'attachment', $attachmentoptions, $sitecontext, 'blog_attachment', $entry->id);
 
-$editordraftid = file_get_submitted_draft_itemid('summary');
-$currenttext = file_prepare_draft_area($editordraftid, $PAGE->context->id, 'blog_post', empty($id) ? null : $id, array('subdirs'=>true), @$existing->summary);
+if (!empty($CFG->usetags) && !empty($entry->id)) {
+    include_once($CFG->dirroot.'/tag/lib.php');
+    $entry->tags = tag_get_tags_array('post', $entry->id);
+}
 
-$data = array('id'=>$id, 'summary'=>array('text'=>$currenttext, 'format'=>FORMAT_HTML, 'itemid' => $editordraftid));
-$blogeditform->set_data($data); // set defaults
+$entry->action = $action;
+// set defaults
+$blogeditform->set_data($entry);
 
-if ($blogeditform->is_cancelled()){
+if ($blogeditform->is_cancelled()) {
     redirect($returnurl);
-} else if ($fromform = $blogeditform->get_data()){
+
+} else if ($data = $blogeditform->get_data()){
 
-    //save stuff in db
     switch ($action) {
         case 'add':
-            $blogentry = new blog_entry($fromform, $blogeditform);
-            $blogentry->summary = file_save_draft_area_files($fromform->summary['itemid'], $PAGE->context->id, 'blog_post', $blogentry->id, array('subdirs'=>true), $fromform->summary['text']);
+            $blogentry = new blog_entry(null, $data, $blogeditform);
             $blogentry->add();
+            $blogentry->edit($data, $blogeditform, $summaryoptions, $attachmentoptions);
         break;
 
         case 'edit':
-            if (!$existing) {
+            if (empty($entry->id)) {
                 print_error('wrongentryid', 'blog');
             }
-            $existing->edit($fromform, $blogeditform);
+
+            $entry->edit($data, $blogeditform, $summaryoptions, $attachmentoptions);
         break;
+
         default :
             print_error('invalidaction');
     }
+
     redirect($returnurl);
 }
 
@@ -181,68 +203,40 @@
         $strformheading = get_string('addnewentry', 'blog');
         $entry->action       = $action;
 
-        if ($courseid) {  //pre-select the course for associations
+        if ($CFG->useblogassociations) {
+
+            //pre-select the course for associations
+            if ($courseid) {
-            $context = get_context_instance(CONTEXT_COURSE, $courseid);
-            $entry->courseassoc = $context->id;
-        }
+                $context = get_context_instance(CONTEXT_COURSE, $courseid);
+                $entry->courseassoc = $context->id;
+            }
 
-        if ($modid) { //pre-select the mod for associations
+            //pre-select the mod for associations
+            if ($modid) {
-            $context = get_context_instance(CONTEXT_MODULE, $modid);
+                $context = get_context_instance(CONTEXT_MODULE, $modid);
-            $entry->modassoc = array($context->id);
+                $entry->modassoc = $context->id;
+            }
         }
         break;
 
     case 'edit':
-        if (!$existing) {
+        if (empty($entry->id)) {
             print_error('wrongentryid', 'blog');
         }
-
-        $entry->id           = $existing->id;
-        $entry->subject      = $existing->subject;
-        $entry->fakesubject  = $existing->subject;
-        $entry->summary      = $existing->summary;
-        $entry->fakesummary  = $existing->summary;
-        $entry->publishstate = $existing->publishstate;
-        $entry->format       = $existing->format;
-        $entry->tags         = tag_get_tags_array('blog_entries', $entry->id);
-        $entry->action       = $action;
-
-        if (!empty($existing->courseassoc)) {
-            $entry->courseassoc = $existing->courseassoc;
-        }
-
-        if (!empty($existing->modassoc)) {
-            $entry->modassoc = $existing->modassoc;
-        }
-
+        $entry->tags = tag_get_tags_array('post', $entry->id);
         $strformheading = get_string('updateentrywithid', 'blog');
 
         break;
+
     default :
         print_error('unknowaction');
 }
 
 $entry->modid = $modid;
 $entry->courseid = $courseid;
-$entry->attachments = $draftitemid;
-$entry->summary = array('text' => @$existing->summary, 'format' => empty($existing->summaryformat) ? FORMAT_HTML : $existing->summaryformat, 'itemid' => $editordraftid);
-$entry->summaryformat = (empty($existing->summaryformat)) ? FORMAT_HTML : $existing->summaryformat;
-$PAGE->requires->data_for_js('blog_edit_existing', $entry);
-
-// done here in order to allow deleting of entries with wrong user id above
-if (!$user = $DB->get_record('user', array('id'=>$userid))) {
-    print_error('invaliduserid');
-}
-
-$PAGE->requires->js('blog/edit_form.js');
 
 echo $OUTPUT->header();
-
-$blogeditform->set_data($entry);
 $blogeditform->display();
-
-$PAGE->requires->js_function_call('select_initial_course');
-
 echo $OUTPUT->footer();
 
 die;
Index: blog/edit_form.php
=========================================================
--- blog/edit_form.php	(revision 1.25)
+++ blog/edit_form.php	Wed Oct 28 16:11:52 WST 2009
@@ -21,29 +21,32 @@
     public $modnames = array();
 
     function definition() {
-        global $CFG, $COURSE, $USER, $DB, $PAGE;
+        global $CFG, $DB;
 
-        $mform    =& $this->_form;
+        $mform =& $this->_form;
 
-        $entryid  = $this->_customdata['id'];
-        $existing = $this->_customdata['existing'];
+        $entry = $this->_customdata['entry'];
+        $courseid = $this->_customdata['courseid'];
+        $modid = $this->_customdata['modid'];
+        $summaryoptions = $this->_customdata['summaryoptions'];
+        $attachmentoptions = $this->_customdata['attachmentoptions'];
         $sitecontext = $this->_customdata['sitecontext'];
 
         $mform->addElement('header', 'general', get_string('general', 'form'));
 
         $mform->addElement('text', 'subject', get_string('entrytitle', 'blog'), 'size="60"');
-        $mform->addElement('editor', 'summary', get_string('entrybody', 'blog'), null, array('trusttext'=>true, 'subdirs'=>true, 'maxfiles' => -1));
+        $mform->addElement('editor', 'summary_editor', get_string('entrybody', 'blog'), null, $summaryoptions);
 
         $mform->setType('subject', PARAM_TEXT);
         $mform->addRule('subject', get_string('emptytitle', 'blog'), 'required', null, 'client');
 
-        $mform->setType('summary', PARAM_RAW);
-        $mform->addRule('summary', get_string('emptybody', 'blog'), 'required', null, 'client');
-        $mform->setHelpButton('summary', array('writing', 'richtext2'), false, 'editorhelpbutton');
+        $mform->setType('summary_editor', PARAM_RAW);
+        $mform->addRule('summary_editor', get_string('emptybody', 'blog'), 'required', null, 'client');
+        $mform->setHelpButton('summary_editor', array('writing', 'richtext2'), false, 'editorhelpbutton');
 
         $mform->addElement('format', 'summaryformat', get_string('format'));
 
-        $mform->addElement('filemanager', 'attachments', get_string('attachment', 'forum'));
+        $mform->addElement('filemanager', 'attachment_filemanager', get_string('attachment', 'forum'), null, $attachmentoptions);
 
         //disable publishstate options that are not allowed
         $publishstates = array();
@@ -56,7 +59,7 @@
 
         $mform->addElement('select', 'publishstate', get_string('publishto', 'blog'), $publishstates);
         $mform->setHelpButton('publishstate', array('publish_state', get_string('publishto', 'blog'), 'blog'));
-
+        $mform->setDefault('publishstate', 0);
 
         if (!empty($CFG->usetags)) {
             $mform->addElement('header', 'tagshdr', get_string('tags', 'tag'));
@@ -66,45 +69,38 @@
         $allmodnames = array();
 
         if (!empty($CFG->useblogassociations)) {
+            if ((!empty($entry->courseassoc) || (!empty($courseid) && empty($modid))) && has_capability('moodle/blog:associatecourse', $sitecontext)) {
+                if (!empty($courseid)) {
+                    $course = $DB->get_record('course', array('id' => $courseid));
-            $mform->addElement('header', 'assochdr', get_string('associations', 'blog'));
+                    $mform->addElement('header', 'assochdr', get_string('associations', 'blog'));
-            $mform->addElement('static', 'assocdescription', '', get_string('assocdescription', 'blog'));
-            if (has_capability('moodle/site:doanything', get_context_instance(CONTEXT_USER, $USER->id))) {
-                $courses = get_courses('all', 'visible DESC, fullname ASC');
+                    $context = get_context_instance(CONTEXT_COURSE, $courseid);
+                    $a->coursename = $course->fullname;
+                    $contextid = $context->id;
-            } else {
+                } else {
-                $courses = get_my_courses($USER->id, 'visible DESC, fullname ASC');
+                    $sql = 'SELECT fullname FROM {course} cr LEFT JOIN {context} ct ON ct.instanceid = cr.id WHERE ct.id = ?';
+                    $a->coursename = $DB->get_field_sql($sql, array($entry->courseassoc));
+                    $contextid = $entry->courseassoc;
-            }
+                }
 
-            $coursenames[0] = 'none';
-
-            if (!empty($courses)) {
-
-                foreach ($courses as $course) {
-                    $coursenames[$course->context->id] = $course->fullname;
-                    $modinfo = get_fast_modinfo($course, $USER->id);
-                    $coursecontextpath = $DB->get_field('context', 'path', array('id' => $course->context->id));
-
-                    foreach ($modinfo->instances as $modname => $instances) {
-
-                        foreach ($instances as $modid => $mod) {
-                            $modcontextid = $DB->get_field_select('context', 'id',
-                                'instanceid = '.$mod->id.' AND ' .
-                                'contextlevel = ' . CONTEXT_MODULE . ' AND ' .
-                                'path LIKE \''.$coursecontextpath.'/%\'');
-
-                            $modstring = $mod->name . ' (' . get_plugin_name($modname) . ')';
-                            $this->modnames[$course->context->id][$modcontextid] = $modstring;
-                            $allmodnames[$modcontextid] = $course->shortname . " - " . $modstring;
-                        }
-                    }
-                }
+                $mform->addElement('advcheckbox', 'courseassoc', get_string('associatewithcourse', 'blog', $a), null, null, array(0, $contextid));
+                $mform->setDefault('courseassoc', $contextid);
+            } else if ((!empty($entry->modassoc) || !empty($modid)) && has_capability('moodle/blog:associatemodule', $sitecontext)) {
+                if (!empty($modid)) {
+                    $mod = get_coursemodule_from_id(false, $modid);
+                    $a->modtype = get_string('modulename', $mod->modname);
+                    $a->modname = $mod->name;
+                    $context = get_context_instance(CONTEXT_MODULE, $modid);
+                } else {
+                    $context = $DB->get_record('context', array('id' => $entry->modassoc));
+                    $cm = $DB->get_record('course_modules', array('id' => $context->instanceid));
+                    $a->modtype = $DB->get_field('modules', 'name', array('id' => $cm->module));
+                    $a->modname = $DB->get_field($a->modtype, 'name', array('id' => $cm->instance));
-            }
+                }
-            $mform->addElement('select', 'courseassoc', get_string('course'), $coursenames, 'onchange="addCourseAssociations()"');
-            $mform->setAdvanced('courseassoc');
-            $selectassoc = &$mform->addElement('select', 'modassoc', get_string('managemodules'), $allmodnames);
-            $mform->setAdvanced('modassoc');
-            $selectassoc->setMultiple(true);
-            $PAGE->requires->data_for_js('blog_edit_form_modnames', $this->modnames);
 
+                $mform->addElement('header', 'assochdr', get_string('associations', 'blog'));
+                $mform->addElement('advcheckbox', 'modassoc', get_string('associatewithmodule', 'blog', $a), null, null, array(0, $context->id));
+                $mform->setDefault('modassoc', $context->id);
+            }
         }
 
         $this->add_action_buttons();
@@ -112,40 +108,30 @@
         $mform->setType('action', PARAM_ACTION);
         $mform->setDefault('action', '');
 
-        $mform->addElement('hidden', 'courseid');
-        $mform->setType('courseid', PARAM_INT);
-
         $mform->addElement('hidden', 'entryid');
         $mform->setType('entryid', PARAM_INT);
-        $mform->setDefault('entryid', $entryid);
+        $mform->setDefault('entryid', $entry->id);
 
         $mform->addElement('hidden', 'modid');
         $mform->setType('modid', PARAM_INT);
-        $mform->setDefault('modid', 0);
+        $mform->setDefault('modid', $modid);
 
         $mform->addElement('hidden', 'courseid');
         $mform->setType('courseid', PARAM_INT);
-        $mform->setDefault('courseid', 0);
-
-        // $this->set_data($existing);
+        $mform->setDefault('courseid', $courseid);
     }
 
     function validation($data, $files) {
         global $CFG, $DB, $USER;
 
         $errors = array();
-
-        if (empty($data['courseassoc']) && ($data['publishstate'] == 'course' || $data['publishstate'] == 'group') && !empty($CFG->useblogassociations)) {
-            return array('publishstate' => get_string('mustassociatecourse', 'blog'));
-        }
+        $sitecontext = get_context_instance(CONTEXT_SYSTEM);
 
-        //validate course association
-        if (!empty($data['courseassoc'])) {
+        // validate course association
+        if (!empty($data['courseassoc']) && has_capability('moodle/blog:associatecourse', $sitecontext)) {
             $coursecontext = $DB->get_record('context', array('id' => $data['courseassoc'], 'contextlevel' => CONTEXT_COURSE));
 
-            if ($coursecontext)  {    //insure associated course has a valid context id
-                //insure the user has access to this course
-
+            if ($coursecontext)  {
                 if (!has_capability('moodle/course:view', $coursecontext, $USER->id)) {
                     $errors['courseassoc'] = get_string('studentnotallowed', '', fullname($USER, true));
                 }
@@ -154,34 +140,32 @@
             }
         }
 
-        //validate mod associations
+        // validate mod association
         if (!empty($data['modassoc'])) {
-            //insure mods are valid
+            $modcontextid = $data['modassoc'];
 
-            foreach ($data['modassoc'] as $modid) {
-                $modcontext = $DB->get_record('context', array('id' => $modid, 'contextlevel' => CONTEXT_MODULE));
+            $modcontext = $DB->get_record('context', array('id' => $modcontextid, 'contextlevel' => CONTEXT_MODULE));
 
-                if ($modcontext) {  //insure associated mod has a valid context id
-                    //get context of the mod's course
+            if ($modcontext) {
+                // get context of the mod's course
-                    $path = split('/', $modcontext->path);
-                    $coursecontext = $DB->get_record('context', array('id' => $path[(count($path) - 2)]));
+                $path = split('/', $modcontext->path);
+                $coursecontext = $DB->get_record('context', array('id' => $path[(count($path) - 2)]));
 
-                    //insure only one course is associated
+                // ensure only one course is associated
-                    if (!empty($data['courseassoc'])) {
-                        if ($data['courseassoc'] != $coursecontext->id) {
-                            $errors['modassoc'] = get_string('onlyassociateonecourse', 'blog');
-                        }
-                    } else {
-                        $data['courseassoc'] = $coursecontext->id;
-                    }
+                if (!empty($data['courseassoc'])) {
+                    if ($data['courseassoc'] != $coursecontext->id) {
+                        $errors['modassoc'] = get_string('onlyassociateonecourse', 'blog');
+                    }
+                } else {
+                    $data['courseassoc'] = $coursecontext->id;
+                }
 
-                    //insure the user has access to each mod's course
+                // ensure the user has access to each mod's course
-                    if (!has_capability('moodle/course:view', $coursecontext)) {
-                        $errors['modassoc'] = get_string('studentnotallowed', '', fullname($USER, true));
-                    }
-                } else {
-                    $errors['modassoc'] = get_string('invalidcontextid', 'blog');
+                if (!has_capability('moodle/course:view', $coursecontext)) {
+                    $errors['modassoc'] = get_string('studentnotallowed', '', fullname($USER, true));
+                }
+            } else {
+                $errors['modassoc'] = get_string('invalidcontextid', 'blog');
-                }
             }
         }
 
@@ -190,24 +174,4 @@
         }
         return true;
     }
-
-    /**
-     * This function sets up options of otag select element. This is called from definition and also
-     * after adding new official tags with the add tag button.
-     *
-     */
-    function otags_select_setup(){
-        global $DB;
-
-        $mform =& $this->_form;
-        if ($otagsselect =& $mform->getElement('otags')) {
-            $otagsselect->removeOptions();
-        }
-        $namefield = empty($CFG->keeptagnamecase) ? 'name' : 'rawname';
-        if ($otags = $DB->get_records_sql_menu("SELECT id, $namefield FROM {tag} WHERE tagtype='official' ORDER by $namefield ASC")) {
-            $otagsselect->loadArray($otags);
-        }
-
-    }
-
 }
Index: blog/external_blog_edit.php
=========================================================
--- blog/external_blog_edit.php	(revision 0)
+++ blog/external_blog_edit.php	Fri Oct 23 07:55:06 WST 2009
@@ -0,0 +1,127 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+
+/**
+ * Form page for an external blog link.
+ *
+ * @package    moodlecore
+ * @subpackage blog
+ * @copyright  2009 Nicolas Connault
+ * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+require_once('../config.php');
+require_once('lib.php');
+require_once('external_blog_edit_form.php');
+require_once($CFG->libdir . '/simplepie/moodle_simplepie.php');
+require_once($CFG->dirroot.'/tag/lib.php');
+
+require_login();
+require_capability('moodle/blog:manageexternal', get_context_instance(CONTEXT_SYSTEM));
+
+// TODO redirect if $CFG->useexternalblogs is off, $CFG->maxexternalblogsperuser == 0, or if user doesn't have caps to manage external blogs
+
+$id = optional_param('id', null, PARAM_INT);
+$PAGE->set_url('/blog/external_blog_edit.php', array('id' => $id));
+
+$returnurl = new moodle_url($CFG->wwwroot . '/blog/external_blogs.php');
+
+$action = (empty($id)) ? 'add' : 'edit';
+
+$external = new stdClass();
+
+// Check that this id exists
+if (!empty($id) && !$DB->record_exists('blog_external', array('id' => $id))) {
+    print_error('wrongexternalid', 'blog');
+} elseif (!empty($id)) {
+    $external = $DB->get_record('blog_external', array('id' => $id));
+}
+
+$strformheading = ($action == 'edit') ? get_string('editexternalblog', 'blog') : get_string('addnewexternalblog', 'blog');
+$strexternalblogs = get_string('externalblogs','blog');
+$strblogs = get_string('blogs','blog');
+
+$externalblogform = new blog_edit_external_form();
+
+if ($externalblogform->is_cancelled()){
+    redirect($returnurl);
+
+} else if ($data = $externalblogform->get_data()) {
+    //save stuff in db
+    switch ($action) {
+        case 'add':
+            $rss = new moodle_simplepie($data->url);
+
+            $newexternal = new stdClass();
+            $newexternal->name = (empty($data->name)) ? $rss->get_title() : $data->name;
+            $newexternal->description = (empty($data->description)) ? $rss->get_description() : $data->description;
+            $newexternal->userid = $USER->id;
+            $newexternal->url = $data->url;
+            $newexternal->filtertags = $data->filtertags;
+            $newexternal->timemodified = mktime();
+
+            if ($newexternal->id = $DB->insert_record('blog_external', $newexternal)) {
+                blog_sync_external_entries($newexternal);
+                tag_set('blog_external', $newexternal->id, $data->autotags);
+            }
+
+            break;
+
+        case 'edit':
+            if ($data->id && $DB->record_exists('blog_external', array('id' => $data->id))) {
+
+                $rss = new moodle_simplepie($data->url);
+
+                $external->id = $data->id;
+                $external->name = (empty($data->name)) ? $rss->get_title() : $data->name;
+                $external->description = (empty($data->description)) ? $rss->get_description() : $data->description;
+                $external->userid = $USER->id;
+                $external->url = $data->url;
+                $external->filtertags = $data->filtertags;
+                $external->timemodified = mktime();
+
+                if ($DB->update_record('blog_external', $external)) {
+                    tag_set('blog_external', $external->id, explode(',', $data->autotags));
+                }
+
+            } else {
+                print_error('wrongexternalid', 'blog');
+            }
+
+            break;
+
+        default :
+            print_error('invalidaction');
+    }
+
+    redirect($returnurl);
+}
+
+$PAGE->navbar->add(fullname($USER), new moodle_url($CFG->wwwroot.'/user/view.php', array('id'=>$USER->id)));
+$PAGE->navbar->add($strblogs, new moodle_url($CFG->wwwroot.'/blog/index.php', array('userid'=>$USER->id)));
+$PAGE->navbar->add($strformheading);
+$PAGE->set_heading("$SITE->shortname: $strblogs: $strexternalblogs", $SITE->fullname);
+$PAGE->set_title("$SITE->shortname: $strblogs: $strexternalblogs");
+
+echo $OUTPUT->header();
+echo $OUTPUT->heading($strformheading, 2);
+
+$externalblogform->set_data($external);
+$externalblogform->display();
+
+echo $OUTPUT->footer();
